#drinc:libraries/dos.g
#iff.g

uint CurrentIndent;
Handle_t StdOut;

proc writeString(*char str)void:
    register *char p;

    p := str;
    while p* ~= '\e' do
	p := p + 1;
    od;
    ignore Write(StdOut, str, p - str);
corp;

proc writeCount(register ulong count)void:
    [11] char buffer;
    register *char p;

    p := &buffer[10];
    p* := '\e';
    while
	p := p - 1;
	p* := count % 10 + '0';
	count := count / 10;
	count ~= 0
    do
    od;
    writeString(p);
corp;

proc indent()void:
    register uint i;

    for i from 1 upto CurrentIndent do
	writeString("  ");
    od;
corp;

proc writeChunk(*char chunkType; ulong remaining; [4] char subType)void:

    indent();
    writeString(chunkType);
    writeCount(remaining + sizeof(IFFID_t));
    writeString(" ");
    ignore Write(StdOut, &subType, 4);
    writeString("\n");
    CurrentIndent := CurrentIndent + 1;
corp;

proc readCat(*IFFContext_t context; IFFID_t subId)bool:
    bool res;

    writeChunk("CAT  ", context*.iff_totalRemaining, subId.iff_char);
    res := IFFReadCatTail(context);
    CurrentIndent := CurrentIndent - 1;
    res
corp;

proc readList(*IFFContext_t context; IFFID_t subId)bool:
    bool res;

    writeChunk("LIST ", context*.iff_totalRemaining, subId.iff_char);
    res := IFFReadListTail(context);
    CurrentIndent := CurrentIndent - 1;
    res
corp;

proc readForm(*IFFContext_t context; IFFID_t subId)bool:
    bool res;

    writeChunk("FORM ", context*.iff_totalRemaining, subId.iff_char);
    res := IFFReadFormTail(context);
    CurrentIndent := CurrentIndent - 1;
    res
corp;

proc readProp(*IFFContext_t context; IFFID_t subId)bool:
    bool res;

    writeChunk("PROP ", context*.iff_totalRemaining, subId.iff_char);
    res := IFFReadPropTail(context);
    CurrentIndent := CurrentIndent - 1;
    res
corp;

proc readOther(*IFFContext_t context; IFFID_t id)bool:

    indent();
    ignore Write(StdOut, &id.iff_char, 4);
    writeString(" ");
    writeCount(context*.iff_totalRemaining);
    writeString("\n");
    IFFSkipChunk(context)
corp;

proc writeFailure(IFFError_t errorCode)void:

    writeString("Failed - ");
    writeString(
	case errorCode
	incase iff_ok:
	    "no error"
	incase iff_noFile:
	    "can't open file"
	incase iff_notIFF:
	    "not IFF file"
	incase iff_notEnough:
	    "file or chunk too short"
	incase iff_tooMuch:
	    "file or chunk too long"
	incase iff_badIFF:
	    "misformed IFF file"
	incase iff_illegalIFF:
	    "illegal structure for IFF file"
	default:
	    "unknown error"
	esac);
    writeString("\n");
corp;

proc main()void:
    extern
	_d_pars_initialize()void,
	GetPar()*char;
    IFFClient_t client;
    register *char par, p;

    if OpenDosLibrary(0) ~= nil then
	StdOut := Output();
	_d_pars_initialize();
	client.iff_readForm := readForm;
	client.iff_readList := readList;
	client.iff_readCat := readCat;
	client.iff_readProp := readProp;
	client.iff_readOther := readOther;
	while
	    par := GetPar();
	    par ~= nil
	do
	    if par* = '"' then
		par := par + sizeof(char);
		p := par;
		while p* ~= '"' and p* ~= '\e' do
		    p := p + sizeof(char);
		od;
		if p* = '"' then
		    p* := '\e';
		fi;
	    fi;
	    writeString(par);
	    writeString(":");
	    writeString("\n");
	    if IFFReadFile(par, &client) then
		writeString("Success\n");
	    else
		writeFailure(client.iff_error);
	    fi;
	od;
	CloseDosLibrary();
    fi;
corp;
