#iff.g
#iffILBM.g
#drinc:graphics/gfx.g

proc IFFReadBBMHD(*IFFContext_t context; *BitMapHeader_t bmh)bool:

    IFFRead(context, bmh, sizeof(BitMapHeader_t))
corp;

proc IFFReadBCMAP(register *IFFContext_t context;
		  register *uint colorMap; register *ushort pNRegs)bool:
    ColorRegister_t colorReg;
    register uint count, extra;
    register bool ok;

    ok := true;
    count := context*.iff_totalRemaining / sizeof(ColorRegister_t);
    if count * sizeof(ColorRegister_t) ~= context*.iff_totalRemaining then
	ok := false;
	context*.iff_client*.iff_error := iff_badIFF;
    fi;
    if count < pNRegs* then
	extra := 0;
	pNRegs* := count;
    else
	extra := count - pNRegs*;
	count := pNRegs*;
    fi;

    while count ~= 0 do
	count := count - 1;
	if IFFRead(context, &colorReg, sizeof(ColorRegister_t)) then
	    colorMap* :=
		(make(colorReg.cr_red	>> 4, uint) << 8) |
		(make(colorReg.cr_green >> 4, uint) << 4) |
		(make(colorReg.cr_blue	>> 4, uint) << 0);
	    colorMap := colorMap + sizeof(uint);
	else
	    ok := false;
	    count := 0;
	fi;
    od;
    if extra ~= 0 then
	if not IFFSkip(context, extra * sizeof(ColorRegister_t)) then
	    ok := false;
	fi;
    fi;
    ok
corp;

proc IFFReadBGRAB(*IFFContext_t context; *Point2D_t p2d)bool:

    IFFRead(context, p2d, sizeof(Point2D_t))
corp;

proc IFFReadBDEST(*IFFContext_t context; *DestMerge_t dm)bool:

    IFFRead(context, dm, sizeof(DestMerge_t))
corp;

proc IFFReadBSPRT(*IFFContext_t context; *SpritePrecedence_t sp)bool:

    IFFRead(context, sp, sizeof(SpritePrecedence_t))
corp;

proc IFFReadBCAMG(*IFFContext_t context; *ViewPortMode_t vpm)bool:

    IFFRead(context, vpm, sizeof(ViewPortMode_t))
corp;

proc IFFReadBCRNG(*IFFContext_t context; *CRange_t cr)bool:

    IFFRead(context, cr, sizeof(CRange_t))
corp;

proc IFFReadBBODY(register *IFFContext_t context; register *BitMap_t bitmap;
		  *uint maskPlane; register *BitMapHeader_t bmHdr)bool:
    [MAX_PLANES + 1] *uint planes;
    register *IFFClient_t client @ bmHdr;
    register *byte p @ bitmap;
    register uint plane, i, n2, bytesPerRow;
    uint planeCount, rowCount, row;
    BCompression_t compression;
    bool ok;
    byte b;
    register short n @ n2;
    short nPrime;

    compression := bmHdr*.bmh_compression;
    bytesPerRow := (bmHdr*.bmh_w + 15) / 16 * 2;
    planeCount := bmHdr*.bmh_nPlanes;
    if bmHdr*.bmh_masking = bmsk_hasMask then
	if maskPlane ~= nil then
	    planes[planeCount] := maskPlane;
	else
	    planes[planeCount] := nil;
	fi;
	planeCount := planeCount + 1;
    fi;
    rowCount := bmHdr*.bmh_h;

    /* notice the ugly cheat - all references to bmHdr are before here, and
       all references to client are after here, so they can share the same
       register */

    ok := true;
    client := context*.iff_client;
    if compression > bcmp_byteRun1 then
	ok := false;
	client*.iff_error := iff_badIFF;
    fi;
    if bytesPerRow ~= bitmap*.bm_BytesPerRow or planeCount > MAX_PLANES then
	ok := false;
	client*.iff_error := iff_badIFF;
    fi;
    if rowCount > bitmap*.bm_Rows then
	rowCount := bitmap*.bm_Rows;
    fi;
    for plane from bitmap*.bm_Depth - 1 downto 0 do
	planes[plane] := bitmap*.bm_Planes[plane];
    od;
    for plane from bitmap*.bm_Depth upto MAX_PLANES - 1 do
	planes[plane] := nil;
    od;
    if ok then
	row := 0;
	while ok and row ~= rowCount do
	    plane := 0;
	    while ok and plane ~= planeCount do
		p := pretend(planes[plane], *byte);
		if compression = bcmp_none then
		    if p = nil then
			if not IFFSkip(context, bytesPerRow) then
			    ok := false;
			fi;
		    else
			if not IFFRead(context, p, bytesPerRow) then
			    ok := false;
			fi;
			p := p + bytesPerRow;
		    fi;
		else
		    i := bytesPerRow;
		    while ok and i ~= 0 do
			if IFFRead(context, &nPrime, 1) then
			    n := nPrime;
			    if n >= 0 then
				n2 := make(n, int) + 1;
				if n2 <= i then
				    i := i - n2;
				    if p = nil then
					if not IFFSkip(context, n2) then
					    ok := false;
					fi;
				    else
					if not IFFRead(context, p, n2) then
					    ok := false;
					fi;
					p := p + n2;
				    fi;
				else
				    ok := false;
				    client*.iff_error := iff_badIFF;
				fi;
			    elif n ~= -128 then
				n2 := -make(n, int) + 1;
				if n2 <= i then
				    i := i - n2;
				    if IFFRead(context, &b, 1) then
					if p ~= nil then
					    for n2 from n2 - 1 downto 0 do
						p* := b;
						p := p + 1;
					    od;
/*
					    while n2 ~= 0 do
						n2 := n2 - 1;
						p* := b;
						p := p + 1;
					    od;
*/
					fi;
				    else
					ok := false;
				    fi;
				else
				    ok := false;
				    client*.iff_error := iff_badIFF;
				fi;
			    fi;
			else
			    ok := false;
			fi;
		    od;
		fi;
		planes[plane] := pretend(p, *uint);
		plane := plane + 1;
	    od;
	    row := row + 1;
	od;
	if ok then
	    if not IFFSkipChunk(context) then
		ok := false;
	    fi;
	fi;
    fi;
    ok
corp;
