#drinc:exec/miscellaneous.g
#drinc:exec/nodes.g
#drinc:exec/ports.g
#drinc:exec/io.g
#drinc:exec/interrupts.g
#drinc:exec/memory.g
#drinc:devices/timer.g
#drinc:libraries/dos.g
#drinc:hardware/intbits.g

Handle_t StdOut;

[2]*MsgPort_t TimerPort;
[2]*timerequest_t TimerRequest;
[2]*Interrupt_t TimerInterrupt;
[2]bool DeviceOpen;
uint GotHereCount;
bool Enabled, Parity;

proc writeString(*char str)void:
    *char p;

    p := str;
    while p* ~= '\e' do
	p := p + 1;
    od;
    pretend(Write(StdOut, pretend(str, *byte), p - str), void);
corp;

proc writeCount(ulong count)void:
    [11] char buffer;
    *char p;

    p := &buffer[10];
    p* := '\e';
    while
	p := p - 1;
	p* := count % 10 + '0';
	count := count / 10;
	count ~= 0
    do
    od;
    writeString(p);
corp;

proc timerEnable(bool which)void:

    TimerRequest[which]*.tr_time.tv_secs := 1;
    TimerRequest[which]*.tr_time.tv_micro := 0;
    TimerRequest[which]*.tr_node.io_Command := TR_ADDREQUEST;
    SendIO(&TimerRequest[which]*.tr_node);
corp;

proc timerHandler()void:

    GotHereCount := GotHereCount + 1;
    if Enabled then
	Parity := not Parity;
	timerEnable(Parity);
    fi;
corp;

proc deleteBlinker(bool which)void:

    if TimerInterrupt[which] ~= nil then
	FreeMem(pretend(TimerInterrupt[which], *byte), sizeof(Interrupt_t));
    fi;
    if DeviceOpen[which] then
	CloseDevice(&TimerRequest[which]*.tr_node);
    fi;
    if TimerRequest[which] ~= nil then
	DeleteExtIO(&TimerRequest[which]*.tr_node, sizeof(timerequest_t));
    fi;
    if TimerPort[which] ~= nil then
	DeletePort(TimerPort[which]);
    fi;
corp;

proc createBlinker(bool which)bool:

    TimerRequest[which] := nil;
    TimerInterrupt[which] := nil;
    DeviceOpen[which] := false;
    TimerPort[which] := CreatePort(nil, 0);
    if TimerPort[which] ~= nil then
	TimerRequest[which] :=
	    pretend(CreateExtIO(TimerPort[which], sizeof(timerequest_t)),
		    *timerequest_t);
	if TimerRequest[which] ~= nil then
	    if OpenDevice(TIMERNAME, UNIT_VBLANK,
			  &TimerRequest[which]*.tr_node, 0) = 0 then
		DeviceOpen[which] := true;
		TimerInterrupt[which] :=
		    pretend(AllocMem(sizeof(Interrupt_t), MEMF_PUBLIC),
			    *Interrupt_t);
		if TimerInterrupt[which] ~= nil then
		    TimerInterrupt[which]*.is_Node.ln_Succ := nil;
		    TimerInterrupt[which]*.is_Node.ln_Pred := nil;
		    TimerInterrupt[which]*.is_Node.ln_Type := NT_INTERRUPT;
		    TimerInterrupt[which]*.is_Node.ln_Pri := 0;
		    TimerInterrupt[which]*.is_Node.ln_Name := nil;
		    TimerInterrupt[which]*.is_Code := timerHandler;
		    TimerPort[which]*.mp_Flags :=
			TimerPort[which]*.mp_Flags & ~PF_ACTION | PA_SOFTINT;
		    TimerPort[which]*.mp_SigTask :=
			     pretend(TimerInterrupt[which], *Task_t);
		    true
		else
		    writeString("Can't allocate timer interrupt\n");
		    deleteBlinker(which);
		    false
		fi
	    else
		writeString("Can't open timer device\n");
		deleteBlinker(which);
		false
	    fi
	else
	    writeString("Can't create timer request\n");
	    deleteBlinker(which);
	    false
	fi
    else
	writeString("Can't create timer port\n");
	false
    fi
corp;

proc main()void:

    if OpenExecLibrary(0) ~= nil then
	if OpenDosLibrary(0) ~= nil then
	    StdOut := Output();
	    if createBlinker(true) then
		if createBlinker(false) then
		    GotHereCount := 0;
		    Parity := true;
		    Enabled := true;
		    timerEnable(true);

		    writeString("starting to wait\n");
		    Delay(50 * 20);
		    writeString("done waiting\n");
		    Enabled := false;
		    writeString("GotHereCount = ");
		    writeCount(GotHereCount);
		    writeString("\n");

		    if AbortIO(&TimerRequest[Parity]*.tr_node) ~= 0 then
			writeString("AbortIO failed\n");
		    fi;
/*
		    Delay(50 * 125 / 100);
*/
		    deleteBlinker(false);
		fi;
		deleteBlinker(true);
	    fi;
	    CloseDosLibrary();
	fi;
	CloseExecLibrary();
    fi;
corp;
